﻿using Sandbox.Common.ObjectBuilders;
using Sandbox.ModAPI;
using System;
using System.Collections.Generic;
using VRage.Game;
using VRage.Game.Components;
using VRage.Game.ModAPI;
//using VRage.Game.ModAPI.Interfaces;
using VRage.ModAPI;
using VRageMath;
using Sandbox.Game.Entities;
using System.Linq;
using Sandbox.Game;

namespace Scripts.KSWH
{
    class EnemyShip : MyGameLogicComponent
    {
        public IMyCubeGrid myShip;
        //private VRage.Game.ModAPI.Interfaces.IMyControllableEntity m_cockpit;
        private Sandbox.Game.Entities.IMyControllableEntity m_cockpit;
        public IMyRemoteControl m_remoteControl { get; protected set; }
        public IMyEntity Target;
        //public MyEntity Target;
        public int Range = 10000;
        private String TargetName = "";
        private float dirLengthOld = 999999;
        static float mindist = 500;
        private Double x;
        private Double y;
        private Double forw;
        private Vector2 rot;
        private Double count = 0;
        private Double count2 = 0;
        private Double count3 = 1;
        private Double count4 = 1;
        private bool fullStop = false;
        private bool flagSwitchDampingOn = false;
        private bool flagSwitchDampingOff = false;
        public bool KeenAILoaded { get; private set; }
        private bool flagOnes = false;


        protected string DroneNameProvider => $"Drone_{m_remoteControl.EntityId}";

        private List<IMySlimBlock> m_blocksCache = new List<IMySlimBlock>();

        public EnemyShip(IMyCubeGrid ship, int agroRange)
        {
            myShip = ship;
            string factionTag = "SPRT";
            IMyFaction Faction = MyAPIGateway.Session.Factions.Factions.Values.FirstOrDefault(x => x.Tag == factionTag);
            myShip.ChangeGridOwnership(Faction.FounderId, VRage.Game.MyOwnershipShareModeEnum.Faction);
            //CargoShips.Talk(myShip.DisplayName, "Faction.FounderId = "+ Faction.FounderId);

            Range = agroRange;
            //CargoShips.Talk(myShip.DisplayName, "EnemyShip()");
            GetCockpit();
            GetRemoteControl();
        }

        private void GetCockpit()
        {
            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                return;
            }
            var lst = new List<IMySlimBlock>();
            myShip.GetBlocks(lst, (x) => x.FatBlock is Sandbox.Game.Entities.IMyControllableEntity);

            if ( (lst       == null)
               ||(lst.Count == 0   )
               )
            {
                m_cockpit = null;
                return;
            }

            m_cockpit = lst[0].FatBlock as Sandbox.Game.Entities.IMyControllableEntity;
        }

        private void GetRemoteControl()
        {
            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                return;
            }
            //CargoShips.Talk(myShip.DisplayName, "GetCockpit()");

            var lstSlimBlock = new List<IMySlimBlock>();
            //myShip.GetBlocks(lstSlimBlock, (x) => x.FatBlock is IMyControllableEntity);
            myShip.GetBlocks(lstSlimBlock, (x) => x.FatBlock is Sandbox.ModAPI.Ingame.IMyShipController);
            //CargoShips.Talk(myShip.DisplayName, "lstSlimBlock = " + lstSlimBlock);
            //CargoShips.Talk(myShip.DisplayName, "lstSlimBlock.Count = " + lstSlimBlock.Count);
            if ((lstSlimBlock == null)
              || (lstSlimBlock.Count == 0)
              )
            {
                m_cockpit = null;
                CargoShips.Talk(myShip.DisplayName, "GetCockpit() -> Cockpit nicht gefunden");
                return;
            }

            if ((lstSlimBlock.Count == 2)
              )
            {
                m_remoteControl = lstSlimBlock[1].FatBlock as IMyRemoteControl;
                return;
            }

            if ((lstSlimBlock.Count == 3)
              )
            {
                return;
            }
        }


        public override void UpdateBeforeSimulation()
        {
            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                return;
            }
            
            CargoShips.Talk(myShip.DisplayName, "UpdateBeforeSimulation()");

            if (flagOnes == false)
            {
                // Stürtzt aktuell noch ab
                // spawn and change inventories only server side as it is synchronized automatically
                if (MyAPIGateway.Multiplayer.IsServer)
                {
                    var block = Entity as IMyTerminalBlock;
                    var position = new Vector3D(57565.75, 135197.5, -109742.81);
                    var flags = SpawningOptions.SetNeutralOwner; // | SpawningOptions.RotateFirstCockpitTowardsDirection;
                    var grids = new List<IMyCubeGrid>();
                    MyAPIGateway.PrefabManager.SpawnPrefab(grids, "bp.sbc", position, block.WorldMatrix.Backward, block.WorldMatrix.Up, block.CubeGrid.Physics.LinearVelocity, Vector3.Zero, null, flags, false);

                }
                flagOnes = true;
            }
        }

        public void Update()
        {
            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                return;
            }
            if ( (count % 20) == 0 )
            {

                if ( (count2 % 20) == 0 )
                {
                    UpdateTarget();

                }
                count2++;

                if ( Target == null )
                {
                    CargoShips.Talk(myShip.DisplayName, "Target == null");
                    return;
                }

                //Vector3 dir = Target.GetPosition() - myShip.GetPosition();
                Vector3 dir = myShip.GetPosition();

                if ( (count3 % 50) == 0 )
                {
                    dirLengthOld = dir.Length();
                    
                    try
                    {
                        IMyEntity entity = m_remoteControl as IMyEntity;
                        if (string.IsNullOrEmpty(entity.Name))
                        {
                            m_remoteControl.Name = DroneNameProvider;
                            MyAPIGateway.Entities.SetEntityName(m_remoteControl as IMyEntity, true);
                        }

                        if (KeenAILoaded) return;
                        //(m_cockpit as MyRemoteControl).SetAutoPilotSpeedLimit(m_cockpit.GetSpeedCap());
                        (m_remoteControl as MyRemoteControl).SetAutoPilotSpeedLimit(100);
                        //MyVisualScriptLogicProvider.SetDroneBehaviourFull(m_cockpit.Name, presetName: FighterSetup.Preset, maxPlayerDistance: FighterSetup.SeekDistance, playerPriority: 0, assignToPirates: FighterSetup.AssignToPirates);
                        MyVisualScriptLogicProvider.SetDroneBehaviourFull(m_remoteControl.Name, presetName: "DefaultDirect", maxPlayerDistance: 20000, playerPriority: 10, assignToPirates: true);
                        //MyVisualScriptLogicProvider.SetDroneBehaviourBasic(m_remoteControl.Name, presetName: "Large");
                        //if (FighterSetup.AmbushMode == true) MyVisualScriptLogicProvider.DroneSetAmbushMode(m_cockpit.Name, ambushModeOn: true);
                        MyVisualScriptLogicProvider.DroneSetAmbushMode(m_remoteControl.Name, ambushModeOn: false);
                        MyVisualScriptLogicProvider.TargetingSetWhitelist(m_remoteControl.Name);
                        //MyVisualScriptLogicProvider.DroneSetTarget(m_remoteControl.DisplayName, Target as MyEntity);
                        KeenAILoaded = true;
                        //CargoShips.Talk(myShip.Name, "KeenAILoaded == true");
                        //CargoShips.Talk(myShip.Name, "m_remoteControl.Name = "+ m_remoteControl.Name);
                        CargoShips.Talk(myShip.Name, "m_remoteControl.DisplayName = " + m_remoteControl.DisplayName);
                        CargoShips.Talk(myShip.Name, "DroneHasAI(m_remoteControl.DisplayName) = " + MyVisualScriptLogicProvider.DroneHasAI(m_remoteControl.DisplayName));
                        CargoShips.Talk(myShip.Name, "DroneHasAI(myShip.DisplayName) = " + MyVisualScriptLogicProvider.DroneHasAI(myShip.DisplayName));
                        //CargoShips.Talk(myShip.Name, "Target.Name = " + Target.Name);
                        //CargoShips.Talk(myShip.Name, "m_cockpit.Name = " + (m_cockpit as MyRemoteControl).Name);
                    }
                    catch (Exception Scrap)
                    {
                        //CargoShips.Talk(myShip.Name, Scrap.ToString());
                    }
                }
                count3++;
            }

            count++;
        }

        private void UpdateTarget()
        {
            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                return;
            }
            //CargoShips.Talk(myShip.DisplayName, "UpdateTarget()");

            if ( Target != null )
            {
                var ship = Target as IMyCubeGrid;

                if ( (ship != null)
                   &&(IsWorkingShip(ship))
                   )
                {
                    return;
                }
            }

            var bs = new BoundingSphereD(myShip.GetPosition(), Range);
            var ents = MyAPIGateway.Entities.GetEntitiesInSphere(ref bs);

            foreach ( var entity in ents )
            {
                var nextShip = entity as IMyCubeGrid;

                if (nextShip != null)
                {
                    if (nextShip.DisplayName == null
                    ||
                       (nextShip.DisplayName != null
                    &&
                       !(nextShip.DisplayName.Contains(CargoShips.Identifier )
                        ))
                       )
                    {
                        Target = entity;
                        break;
                    }
                }
            }
        }

        public bool IsWorkingInvader()
        {
            if ( (!myShip.DisplayName.Contains(CargoShips.Identifier))
               )
               {
                   return false;
               }

            if (m_cockpit == null)
            {
                return false;
            }

            return IsWorkingShip(myShip);
        }

        private bool IsWorkingShip(IMyCubeGrid ship)
        {
            var reactors  = new List<IMySlimBlock>();
            var reactors2 = new List<IMySlimBlock>();
            var reactors3 = new List<IMySlimBlock>();
            var reactors4 = new List<IMySlimBlock>();
            MyDefinitionId reactorDef  = new MyDefinitionId(typeof(MyObjectBuilder_Reactor), "LargeBlockSmallGenerator");
            MyDefinitionId reactorDef2 = new MyDefinitionId(typeof(MyObjectBuilder_Reactor), "LargeBlockLargeGenerator");
            MyDefinitionId reactorDef3 = new MyDefinitionId(typeof(MyObjectBuilder_Reactor), "SmallBlockSmallGenerator");
            MyDefinitionId reactorDef4 = new MyDefinitionId(typeof(MyObjectBuilder_Reactor), "SmallBlockLargeGenerator");
            ship.GetBlocks(reactors , (x) => x.FatBlock != null && x.FatBlock.BlockDefinition == reactorDef );
            ship.GetBlocks(reactors2, (x) => x.FatBlock != null && x.FatBlock.BlockDefinition == reactorDef2);
            ship.GetBlocks(reactors3, (x) => x.FatBlock != null && x.FatBlock.BlockDefinition == reactorDef3);
            ship.GetBlocks(reactors4, (x) => x.FatBlock != null && x.FatBlock.BlockDefinition == reactorDef4);

            bool hasEnergy = false;
            foreach (var reactor in reactors)
            {
                if (reactor != null)
                    hasEnergy |= reactor.FatBlock.IsWorking;
            }
            foreach (var reactor in reactors2)
            {
                if (reactor != null)
                    hasEnergy |= reactor.FatBlock.IsWorking;
            }
            foreach (var reactor in reactors3)
            {
                if (reactor != null)
                    hasEnergy |= reactor.FatBlock.IsWorking;
            }
            foreach (var reactor in reactors4)
            {
                if (reactor != null)
                    hasEnergy |= reactor.FatBlock.IsWorking;
            }
            return hasEnergy;
        }

        private void ApplyAction(List<IMySlimBlock> fatContainers, string action)
        {
            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                return;
            }
            foreach (var b in fatContainers)
            {
                var actObj = (b.FatBlock as IMyTerminalBlock).GetActionWithName(action);
                actObj.Apply(b.FatBlock);
            }
        }
    }
}
